/*
    MSGLIB - a message handling library
    Copyright (C) 1995,1997-98  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: MSG2CODE.C $
   $Locker: ska $	$Name:  $	$State: Rel $

	int msg2ExitCode(MSGID2 id)

	Return the exit code associated with the message.

	Return:
		always 0..255; maybe invalid if the message is not of class 'E'

*/

#include <assert.h>

#include "msg2.h"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: MSG2CODE.C 1.2 1998/10/07 04:42:53 ska Rel ska $";
#endif /*#	defined(RCS_Version) */

int msg2ExitCode(MSGID2 id)
{	
	MsgStr *str;

	/* Fetch the message */
	str = msg2MsgLock(id);		/* msg2Lock() guarantees to never return NULL */
	assert(str);

	return str->exitcode;
}
